package jalview.ws.gui;

import jalview.api.FeatureRenderer;
import jalview.datamodel.AlignmentAnnotation;
import jalview.datamodel.SequenceI;

import java.util.List;
import java.util.Map;

public class AnnotationWsJob extends WsJob
{
  /**
   * sequences (anonymised)
   */
  List<SequenceI> seqs;

  /**
   * mapping to original sequences
   */
  Map<String, SequenceI> seqNames;

  /**
   * first column in the segment of the alignment view that was submitted
   */
  int startPos;

  public int getStartPos()
  {
    return startPos;
  }

  public void setStartPos(int startPos)
  {
    this.startPos = startPos;
  }

  /**
   * outputs
   */
  List<AlignmentAnnotation> annotation = null;

  boolean transferSequenceFeatures = false;

  public boolean isTransferSequenceFeatures()
  {
    return transferSequenceFeatures;
  }

  public void setTransferSequenceFeatures(boolean transferSequenceFeatures)
  {
    this.transferSequenceFeatures = transferSequenceFeatures;
  }

  public List<AlignmentAnnotation> getAnnotation()
  {
    return annotation;
  }

  public void setAnnotation(List<AlignmentAnnotation> annotation)
  {
    this.annotation = annotation;
  }

  @Override
  public boolean hasResults()
  {
    return (isSubmitted() && isFinished()
            && (annotation != null || transferSequenceFeatures));
  }

  public List<SequenceI> getSeqs()
  {
    return seqs;
  }

  public void setSeqs(List<SequenceI> seqs)
  {
    this.seqs = seqs;
  }

  public Map<String, SequenceI> getSeqNames()
  {
    return seqNames;
  }

  public void setSeqNames(Map<String, SequenceI> seqNames)
  {
    this.seqNames = seqNames;
  }

  /**
   * configured by the WS framework just before results are collected
   */
  FeatureRenderer featureRenderer;

  public void setFeatureRenderer(FeatureRenderer fr)
  {
    this.featureRenderer = fr;
  }
  public FeatureRenderer getFeatureRenderer()
  {
    // TODO Auto-generated method stub
    return featureRenderer;
  }

}
